# Important Notice
### **The latest version is a rework of the add-on, not all features will be ported. If you move from v3 to v4, old settings will be lost!**

You need atleast ElvUI version 12 or higher for the add-on to work.

# General Information
This is a continuation of ElvUI Enhanced and a more liteweight version. Only essential features are added and features that ElvUI can do it self are removed. If you miss specific features from the old v3 version, please let me know and I will consider adding them.

If you find any bugs or features that are not working please let me know by creating a ticket: [https://github.com/nickbock/ElvUI_Enhanced_Again/issues](https://github.com/nickbock/ElvUI_Enhanced_Again/issues "")

If you want to contribute you can find the source on github: [https://github.com/nickbock/ElvUI_Enhanced_Again](https://github.com/nickbock/ElvUI_Enhanced_Again "")

# Whats New
- Moved all the setting to own settings section. This way it more easier to find settings and to change them how you want.
- Rewrite of plugin initialization.
- Settings moved to profiles instead on a per character base.
- All features are disabled by default.
- Own ElvUI Mover group for easy moving of Minimap Button Bar and RaidMarker Bar
- Updated progression tooltip
- Readded Equipment Manager
- Readded range datatext
- Readded Equipment set overlay in bags
- Readded iLvl and Durability on Character screen

## ToDo
- Cleanup old files.
- Updated and cleanup locales.
- Maybe add some more (old) features.

Please Note: This add-on will not function without ElvUI installed. You can download it at http://www.tukui.org.
# Features
### Mini map
- Location information above minimap with coordinates.
- Mini map buttons can be skinned and placed on their own bar that can be moved around.
### Raiding
- Raid Marker Bar for quickly placing target and world markers.
### Equipment Manager
- Automatic Equipment switching on spec change
- Automatic Equipment switching when in battleground
- Equipment Set Overlay for your bag and bank slots showing the equipment sets for an item.
- Item levels and durability information on the character screen.

### Tooltip
- Player Raid Progression information on mouse-over tool tip (requires holding 'shift' key)
### Datatext
- Show the range of a target in a datatext

# Removed Features
You can make a request for only of the old features on: [https://github.com/nickbock/ElvUI_Enhanced_Again](https://github.com/nickbock/ElvUI_Enhanced_Again ""). 
If enough people want it, I will consider adding the feature.

### Mini map
- Hide mini map during combat (disabled by default).
### Automation:
- Auto release in battleground after player dies.
- Automatic changing of the watched faction on your reputation bar to the faction you got reputation points for.
- Automatic role detection for battleground and party/raid groups.
- Automatic selection of highest vendor value quest rewards (you can still pick another if you like).
### Data Texts
- Item Level data text for a quick glance at your currently equipped item levels.
- Quick datatext configuration by CTRL-ALT-RightClick on any datatext panel.
### Visualizations
- Adjustable transparency for the ElvUI interface movers.
- Attack icon on target frame when target is not tapped by you or your group, but you still get credit for the kill when attacking.
- Improved visibility for disconnected party or raid member (lightning icon in frame).
- Watchframe visibility configuration, based on city (resting), pvp, arena, party or raid.
### Unit Frames
- GPS Locator for target and focus frame, showing direction and range to party or raid member.
- Heal Glow: Direct AoE heals will let the unit frames of the affected party / raid members glow for the defined time period.
- Hide role icons (healer/tank/damage) on unit frames while in combat.
- Class Icons for the target frame.
